{Projekt: PASCAL }
{ SCHNITT eines Oktaeders mit                       }
{ einer Dreiecks-Pyramide                                }


{ I. Konstruktions-Parameter                            }
Color 13;  
Write "W A I T" at (11,-9,0);
; 
{ 1. Oktaeder-Parameter                                  }
{ Koordinaten des Schwerpunkts                     }
5                       ->   x;
0                       ->   y;
5                       ->   z;
210                   ->   w;
( x,y,z )  ->  SpO;
{ Richtungsvektor der Hhe                              }
( -2,-2,1 )       ->  VhO;
9                        ->  SlO;

{ 2. Pyramiden-Parameter                                }
{ Koordinaten des Flchenschwerpunkts VW} 
5                       ->   xM;
0                       ->   yM;
5                       ->   zM;
-15                   ->   wM;
( xM,yM,zM )->  SpP;
( 1,.1,10 )      ->  VhP;
{ Seitenlngen                                                     }
12.5                -> SlP1;
9                      -> SlP2;
{ Krperhhe                                                       }
6                     ->   HP;

{ II. Konstruktionen                                             }
{ 1. Oktaeder-Konstruktion                               }
Gerade( Origin,VhO )            -> g;
Parallele( SpO,g )              -> p;
NormalEbene( SpO,p )      -> N;
SqRt( 2 ) * SlO / 2                  -> r;
Kreis( SpO,r,N )               -> k;
Wahl( ?,?,z ) auf k           -> A;
Gerade( A,SpO )                -> h;
k  h                                   -> C;
Normale( SpO,h,N )        -> n;
k  n                                   -> B,D;
Rotation( p,w )    -> pw;
pw A                ->  A;
pw B                ->  B;
pw C                ->  C;
pw D                ->  D;
SlO * SqRt( 2 ) / 2   -> d;
Trage -d von SpO auf p ab  ->   E,F;
              
{ 2. Pyramiden-Konstruktion                             }
Gerade( Origin,VhP )         -> gM;
Parallele( SpP,gM )           -> pM;
NormalEbene( SpP,pM )   -> NM;
Kreis( SpP,SlP1/2,NM )   -> k1M;
Wahl( ?,?,zM ) auf k1M     -> UM;
Gerade( UM,SpP )              -> uM;
uM  k1M                              -> VM;
Kreis( UM,SlP2,NM )         -> k2M; 
k1M  k2M                           -> WM;
Rotation( pM,wM )    -> pMwM;
pMwM UM                ->  U;
pMwM VM                ->  V;
pMwM WM               ->  W;
Trage HP von SpP auf pM ab  ->  X;

{ III. Ebenen-Definition                                       }
{ 1. Oktaeder-Ebenen                                         }
Ebene( A,B,E )        -> Eabe;
Ebene( A,B,F )        -> Eabf;
Ebene( A,D,E )        -> Eade;
Ebene( A,D,F )        -> Eadf;
Ebene( B,C,E )        -> Ebce;
Ebene( B,C,F )        -> Ebcf;
Ebene( C,D,E )        -> Ecde;
Ebene( C,D,F )        -> Ecdf;

{ 2. Pyramiden-Ebenen                                       }
Ebene( U,V,W )        -> Euvw;
Ebene( U,V,X )        -> Euvx;
Ebene( U,W,X )        -> Euwx;
Ebene( V,W,X )        -> Evwx;

{ IV. Geraden-Definitionen                                }
{ 1. Oktaeder-Geraden                                      }
Gerade( A,B )          -> Gab;
Gerade( A,D )          -> Gad;
Gerade( A,E )          -> Gae;
Gerade( A,F )          -> Gaf;
Gerade( B,C )          -> Gbc;
Gerade( B,E )          -> Gbe;
Gerade( B,F )          -> Gbf;
Gerade( C,D )          -> Gcd;
Gerade( C,E )          -> Gce;
Gerade( C,F )          -> Gcf;
Gerade( D,E )          -> Gde;
Gerade( D,F )          -> Gdf;

{ 2. Pyramiden-Geraden                                    }
Gerade( U,V )          -> Guv;
Gerade( U,W )          -> Guw;
Gerade( U,X )          -> Gux;
Gerade( V,W )          -> Gvw;
Gerade( V,X )          -> Gvx;
Gerade( W,X )          -> Gwx;

{ V. Unsichtbare Krperlinien                            }
; 
{ 1. Oktaeder-Linien                                            }
Color 12; 
Draw A D; Draw C D;Draw E D;Draw  F D;

{ 2. Pyramide-Linien                                            }
Color 13; Draw U V;

{ VI. Sichtbare Krperpunkte                            }

{ 1. Oktaeder-Punkte                                          }
Write U at ( 4.1,-6.7, 5.1);
Write V at ( 6.1, 6.3, 4.8);
Write W at (11.3,-0.8, 4.3);
Write X at ( 5.4, 0.1,11.3);

{ 2. Pyramiden-Punkte                                        }
Color 12; 
Write A at (8.3,-5.0,1.9);
Write C at (1.6, 5.0,8.5);
Write E at (0.5,-4.9,7.6);
Write F at (9.4, 4.4,2.7);

{ VII. Schnittkrper                                             }

{ 1. Anschreiben                                                  }
Color 7;  
 Write "W A I T" at (11,-9,0);

Color 13; 
Write "Schnittkrper" at  ( 10,-8.1,0 );

{ 2. Schnittpunkte                                                }
; 
Gux  Eabe             ->  S2;
Gux  Ebce             ->  S3;
Guv  Eabe             ->  S4;
Guv  Ecdf              ->  S5;
Gvw  Eabf             ->  S6;
Gvw  Ebcf             ->  S7;
Gwx  Eabf             -> S10;
Gwx  Ebce             -> S11;
Guw  Eabe             -> S12;
Guw  Eabf             -> S13;
Gbc  Evwx             ->  P2;
Gbc  Euvx              ->  P3;

{ 3. Ausfrbung                                                    }
Color 5; Paint S6 S7 P2 S11 S10;
Color 13;  Paint S10 S11 S3 S2 S12 S13;
Color 4;  Paint S6 S10 S13;
Color 12; Paint S5 S7 P2 P3;
Color 14;  Paint P2 P3 S3 S11;
Color 6;  Paint S2 S4 S12;
Color 8;; Draw S5 S4;

{ VIII. Sichtbare Krperlinien                           }
; 
{ 1. Oktaeder-Linien                                           }
Color 12; 
Draw A B; Draw E B;Draw  F B; Draw C B;
Draw A F C E A;

{ 2. Pyramiden-Linien                                         }
Color 13; 
Draw U X; Draw V X;Draw  W X;
Draw U W V;

{ IX. Unterbruch                                                   }

Meldung "Schnittkrper";

Color 7; 
Write "Schnittkrper" at  ( 10,-8.1,0 );


{ X. Durchdringung                                              }

{ 1. Anschreiben                                                  }
Color 13; 
Write "Durchdringung" at     ( 10,-8.1,0 );

{ 1. Oktaeder Frben                                          }
Color 6; Paint A,E,B;
Color 4;  Paint A,B,F;
Color 14; Paint B,C,E;
Color 12; Paint B,C,F;

{ 2. Pyramide Frben                                          }
Color 13; 
Paint W S10 S13;
Paint X S3 S11;
Paint U S12 S2;
Color 5; 
Paint W S6 S10;
Paint S7 V X S11 P2;